//+------------------------------------------------------------------+
//|                                                   dehole_hst.mq4 |
//|                                                   kukan&alextron |
//|                                              http://www.kukan.ru |
//+------------------------------------------------------------------+
//8  2005 
//
//           , 
//    . , (  ) 
//    ,      - , 
//    .       1 ,  5
//   ,    ,      .
//      ,        
//  ,      ,   .
//           ,      
//  ,     .
// ,    ,        (), 
//  ,           .
//           .
//
//     *.new,     *.hst,  
//,     .
//    
//
// :
//!           
//!       
//!,     ,    , ..
//    
//       *.log    
// 
//
// ,    .
//    ,    
//   .
//
#property copyright "kukan&alextron"
#property link      "http://www.kukan.ru"
#property show_inputs

#define  qty_smb  6     // 

extern   int      m_period=1;          //      - 
extern   string   symbol_0="EURUSD";   //  " " "N"     
extern   string   symbol_1="GBPUSD";
extern   string   symbol_2="AUDUSD";
extern   string   symbol_3="USDCHF";
extern   string   symbol_4="USDJPY";
extern   string   symbol_5="USDCAD";   //   
extern   int      volume_null=0;       //   

//  
string   symbol_m[qty_smb];
// 
int      i_handle[qty_smb];
int      o_handle[qty_smb];
int      log_handle[qty_smb];
//  -  
int      h_time[qty_smb];
double   h_open[qty_smb],h_low[qty_smb],h_high[qty_smb],h_close[qty_smb];
double   h_volume[qty_smb];
double   old_close[qty_smb];     //  
int      old_time[qty_smb];      //   
bool     symbol_list[qty_smb];   // 
//      
int      lg_sk[qty_smb];   //  
int      lg_sk_v[qty_smb]; //  
int      tm_cur=0;         //     
int      ia,ib;            // 
int      cnt_bars=0;       //  
bool     fl_stop=false;     //  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//---- 
//   
for   (int i=0;i<qty_smb;i++)
   {
   //  
   i_handle[i]=FileOpenHistory(symbol_m[i]+m_period+".hst",FILE_BIN|FILE_READ);
   symbol_list[i]=true;
   if(i_handle[i]<0) 
      {
      Print(symbol_m[i],"   ,   ");
      h_time[i]=-1;  //   
      symbol_list[i]=false;
      }
      else
      {
      fl_stop=true;
      }
   //  
   if (h_time[i]>=0 && symbol_list[i])
      {
      o_handle[i]=FileOpenHistory(symbol_m[i]+m_period+".new",FILE_BIN|FILE_WRITE);
      if(o_handle[i]<0) return(-1);
      log_handle[i]=FileOpenHistory(symbol_m[i]+m_period+".log",FILE_BIN|FILE_WRITE);
      if(o_handle[i]<0) return(-1);
      //   
      copy_title_proc(i_handle[i],o_handle[i]);
      }
   }
//       
if (!fl_stop)
   {
   Print("   ");
   return(-1);
   }
//   
//   
tm_cur=0;     //    
for   (i=0;i<qty_smb;i++)
   {
   if (h_time[i]<0)  continue;   // 
   read_bars_hst(i);
   if (h_time[i]==0)
      {
      Print(symbol_m[i],"   ,   ");
      h_time[i]=-1;     //   
      symbol_list[i]=false;
      }
   if (tm_cur<h_time[i])
      {
      tm_cur=h_time[i];
      ia=i;             //      
      }
   old_time[i]=h_time[i];     //  
   old_close[i]=h_close[i];
   }
cnt_bars++;
Print("    ",symbol_m[ia],"  ",TimeToStr(h_time[ia],TIME_DATE|TIME_MINUTES));
//
//         
//       
for   (i=0;i<qty_smb;i++)
   {
   if (h_time[i]<0)  continue;   // 
   while (tm_cur>h_time[i])
      {
      if (h_time[i]==0) 
         {//    0   , 
         //     
         //   ,      
         //       
         Print(symbol_m[i],"     ,    ");
         h_time[i]=-1;  //   
         symbol_list[i]=false;
         break;
         }
      read_bars_hst(i);
      }
   write_text_logs(i," \t "+TimeToStr(tm_cur,TIME_DATE|TIME_MINUTES)+"\n");
   }
//..................................................
//     
//            
//  
//        
while (fl_stop)
   {
   //    
   for   (i=0;i<qty_smb;i++)
      {
      if (symbol_list[i])  //       
         {
         if (tm_cur<h_time[i] || h_time[i]<0)
            {//         
            write_bars_hst_null(i); // 
            lg_sk[i]++;             //  
            lg_sk_v[i]++;           //   
            }
            else
            {//   
            write_bars_hst(i);
            if (lg_sk_v[i]!=0)
               {
               //       
               write_text_logs(i," -"+lg_sk_v[i]+"\t "+TimeToStr(old_time[i],TIME_DATE|TIME_MINUTES)+"\n");
               lg_sk_v[i]=0;
               }            
            }
         }
      }
   //        
   //    
   //       
   //        
   //
   ib=CurTime();  //    :)
   for   (i=0;i<qty_smb;i++)
      {
      if (h_time[i]<0)  continue;   // 
      if (h_time[i]<=tm_cur) read_bars_hst(i);
      if (h_time[i]==0) 
         {
         Print(symbol_m[i],"    ",TimeToStr(old_time[i],TIME_DATE|TIME_MINUTES));
         write_text_logs(i,"   \t "+TimeToStr(old_time[i],TIME_DATE|TIME_MINUTES)+
         "\t  "+cnt_bars+" \n");
         h_time[i]=-1;  //   
         }
         else
         {// 
         //   ib,  ib   
         if (ib>h_time[i]) ib=h_time[i];
         }
      }
   cnt_bars++;
   //       
   tm_cur=ib;
   //
   //      
   //      
   fl_stop=false;
   for   (i=0;i<qty_smb;i++)
      {
      if (h_time[i]>0)  fl_stop=true;  //    :))
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int init()
  {
   symbol_m[0]=symbol_0;
   symbol_m[1]=symbol_1;
   symbol_m[2]=symbol_2;
   symbol_m[3]=symbol_3;
   symbol_m[4]=symbol_4;
   symbol_m[5]=symbol_5;
   //
   ArrayInitialize(i_handle,-1);
   ArrayInitialize(o_handle,-1);
   ArrayInitialize(log_handle,-1);
   ArrayInitialize(h_time,0);
   ArrayInitialize(lg_sk,0);
   ArrayInitialize(lg_sk_v,0);
  }
//+------------------------------------------------------------------+
void deinit()
  {
   //      
for   (int i=0;i<qty_smb;i++)
   {
   if(i_handle[i]>=0) { FileClose(i_handle[i]); i_handle[i]=-1; }       // 
   if(o_handle[i]>=0) { FileClose(o_handle[i]); o_handle[i]=-1; }       // 
   if(log_handle[i]>=0) { FileClose(log_handle[i]); log_handle[i]=-1; } // 
   }
   Print(" ,  "+cnt_bars+"  ");
   //
  }
//+------------------------------------------------------------------+
//    
//     ,   
bool  copy_title_proc(int i_handle,int o_handle)
   //      
   {
   int    i_unused[13];
   //
   FileWriteInteger(o_handle,FileReadInteger(i_handle,LONG_VALUE),LONG_VALUE);   //
   //
   FileWriteString(o_handle,FileReadString(i_handle,64), 64);  //
   FileWriteString(o_handle,FileReadString(i_handle,12), 12);  //
   //
   FileWriteInteger(o_handle,FileReadInteger(i_handle,LONG_VALUE),LONG_VALUE);   //
   FileWriteInteger(o_handle,FileReadInteger(i_handle,LONG_VALUE),LONG_VALUE);   //   
   FileWriteInteger(o_handle,FileReadInteger(i_handle,LONG_VALUE),LONG_VALUE);   //
   FileWriteInteger(o_handle,FileReadInteger(i_handle,LONG_VALUE),LONG_VALUE);   //
   //
   FileReadArray(i_handle,i_unused,0,13);
   FileWriteArray(o_handle,i_unused,0,13);   //
   //
   FileFlush(o_handle);
   //
   return(true);
   }
//+------------------------------------------------------------------+
//       
void  read_bars_hst(int number)
   //number- 
   {
   old_time[number]=h_time[number];       //   
   old_close[number]=h_close[number];     //  
   h_time[number]=FileReadInteger(i_handle[number],LONG_VALUE);
   //
   h_open[number]=FileReadDouble(i_handle[number],DOUBLE_VALUE);
   h_low[number]=FileReadDouble(i_handle[number],DOUBLE_VALUE);
   h_high[number]=FileReadDouble(i_handle[number],DOUBLE_VALUE);
   h_close[number]=FileReadDouble(i_handle[number],DOUBLE_VALUE);
   h_volume[number]=FileReadDouble(i_handle[number],DOUBLE_VALUE);
   //
   }
//+------------------------------------------------------------------+
//     
void   write_bars_hst(int number)
   {
   FileWriteInteger(o_handle[number],h_time[number],LONG_VALUE);
   //
   FileWriteDouble(o_handle[number],h_open[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],h_low[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],h_high[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],h_close[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],h_volume[number],DOUBLE_VALUE);
   //
   FileFlush(o_handle[number]);
   //
   }
//---------------------------------------------------
//      
void   write_bars_hst_null(int number)
   {
   FileWriteInteger(o_handle[number],tm_cur,LONG_VALUE);
   //
   FileWriteDouble(o_handle[number],old_close[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],old_close[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],old_close[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],old_close[number],DOUBLE_VALUE);
   FileWriteDouble(o_handle[number],volume_null,DOUBLE_VALUE);
   //
   FileFlush(o_handle[number]);
   //
   }
//   
void  write_text_logs(int number,string text)
   {
   FileWriteString(log_handle[number],text,StringLen(text));
   FileFlush(log_handle[number]);
   }
//---------------------------------------------------